'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _reject2 = require('lodash/reject');

var _reject3 = _interopRequireDefault(_reject2);

var _some2 = require('lodash/some');

var _some3 = _interopRequireDefault(_some2);

exports.default = function (_ref) {
  var t = _ref.types;

  var functionVisitor = function functionVisitor(path) {
    // Check if we should inject
    if (!(0, _some3.default)(path.node.body.directives, isInjectDirective)) return;
    // Remove ngInject directive
    path.node.body.directives = (0, _reject3.default)( // eslint-disable-line no-param-reassign
    path.node.body.directives, isInjectDirective);
    // Construct array for injection annotations
    var arr = (0, _map3.default)(path.node.params, function (p) {
      return t.stringLiteral(p.name);
    });
    arr.push(path.node);
    // Replace function with array
    path.replaceWith(t.arrayExpression(arr));
  };
  return {
    visitor: {
      ArrowFunctionExpression: functionVisitor,
      FunctionExpression: functionVisitor
    }
  };
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Determines if the given directive is an 'ngInject' directive.
 * @param {Object} d The Directive node from Babylon.
 */
var isInjectDirective = function isInjectDirective(d) {
  return d.value.value === 'ngInject';
};

/**
 * Babel plugin to automatically annotate functions for Angular dependency injection.
 * @param {Object} babel The current babel object.
 * @param {Object} babel.types babel-types
 * @return {Object} Babel visitor.
 */
module.exports = exports['default'];